(********* Matematica - corso di LPL: Laboratorio 2018 *************)
(*******************************************************************)
(* Definizione del Linguaggio SmallC: Nucleo di C esteso           *)
(* Realizzazione di un Esecutore di SmallC utilizzando OCaml       *)
(*******************************************************************)

(* =============================================================== *)
(* The Token, i.e. Lexical Categories *)

type ide = string;;
type num = int;;


(* =============================================================== *)
(* The Syntactic Categories *)

type dcl = 
	Const of ide * num
	| Var of ide * num
	| VarN of ide
	| Array of ide * num
	| SeqDcl of dcl * dcl
	;;
	
type exp = 
	Val of ide
	| Num of num
	| GetArrow of ide * exp
	| Plus of exp * exp
	| Minus of exp * exp
	| Mul of exp * exp
	| Div of exp * exp
	| Eq of exp * exp
	| LT of exp * exp
	| GT of exp * exp
	| Not of exp
	| Or of exp * exp
	| And of exp * exp
	;;
	
type cmd =
	UpdVar of ide * exp
	| UpArray of ide * exp * exp
	| Ifte of exp * cmd * cmd
	| Ift of exp * cmd
	| While of exp * cmd
	| SeqCmd of cmd * cmd
	;;
	
type prog = Program of dcl * cmd | ProgN of cmd;;


(* Operations: Solo 2 per la presentazione dei valori *)

open Printf;;

let toStringI (i:ide) = sprintf("%s")i;;

let toStringN (n:num) = sprintf("%d")n;;

let rec toStringDcl = function
		Const(ide,num) -> 
			let i = toStringI(ide) and n = toStringN(num) in
			sprintf "%s = %s;" i n
		|_ -> ""   (* correggere e completare *)
;;
	
let printDcl d = printf "\n%s\n\n" (toStringDcl d);;


(* Vedi EserciziLab3-2-5.ml per gli esercizi3-5  di Laboratorio3 *)



(* =============================================================== *)
(* The Semantic Structure: Store e Environment *)	

(* Store: Definition *)
type loc = Loc of int;;
type mval = Mval of int
	| Undef;;

type store = Store of int * (loc -> mval);;

(* Store: Operations and Exceptions *)
let storeSize = 1000;;

exception IllegalAddress of string * loc;;
exception UndefinedLoc of string * loc;;
exception StoreSizeExceeded of string * int * int;;

let emptyStore () =  (* inizializzare store *)
		...
		;;
let allocate (Store(d,g)) k =   (* allocare le prime k disponibili, altrimenti... *)
		...
		;;
let upd (Store(d,g)) loc mv =    (* scrivere mv in loc se possibile, altrimenti.. *)
		...
		;;
let getStore (Store(d,g)) loc =  (* valore memorizzato in loc se esiste, altr.... *)
		...
		;;
		
				
						
(* Environment: Definition *)
 type dval = 
	DConst of num
	| DVar of loc
	| DArray of loc
	| Unbound
	;;
	 
type env = Env of (ide -> dval);;  
   
(* Environment: Operations and Exceptions *)
let emptyEnv () =                 (* creare ambiente vuoto *)
		...
		;;
let bind (Env r) ide dval =       (* aggungere binding (ide,dval) *)
		...
		;;		
let getEnv (Env r) ide =		  (* valore denotabile di ide se esiste, altr.... *)
        ...
		;;


(* =============================================================== *)
(* The Semantic Function: dclSem, expSem, cmdSem, progSem *)

(* =============================================================== *)
(* The Semantic Function: dclSem *)











(* =============================================================== *)
(* The Semantic Function: expSem *)
 		



























(* ============================================================================ *)
(* The Semantic Function: cmdSem *)

















(* ============================================================================ *)
(* The Semantic Function: progSem *)





















(* ============================================================================ *)
(* Tests: Abstract Syntax *)
(* dcl *)
let d1 = Const("luigi",26);;
toStringDcl d1;;
printDcl d1;;
let d2 = Var("x", 7);;
let d3 = SeqDcl(d1, d2);;
printDcl d3;;
let d4 = SeqDcl(d3,d3);;
printDcl d4;;
printDcl(SeqDcl(d4, SeqDcl(VarN("y"),Array("Vect",10))));;

(* exp e cmd *) 
let e1 = Plus(Val("x"),Num(17));;
let e2 = Val "z";;
let e = Mul(e1,e2);;
printExp e;;
let c1 = UpArray("A",Mul(Val("i"),Val("j")),e1);;
let c2 = While((Val "z"),SeqCmd(c1,UpdVar("z",Minus((Val "z"),(Num 1)))));;
printCmd c2;;


(* Dobbiamo ottenere una session come sotto.....................................
# #use "Oggi.ml";;
...
val toStringI : ide -> string = <fun>
val toStringN : num -> string = <fun>
val toStringDcl : dcl -> string = <fun>
val printDcl : dcl -> unit = <fun>  ------ modifica lo standard output: stdout
val d1 : dcl = Const ("luigi", 26)
- : string = "luigi = 26;"

luigi = 26;

- : unit = ()
val d2 : dcl = Var ("x", 7)
val d3 : dcl = SeqDcl (Const ("luigi", 26), Var ("x", 7))

luigi = 26;
var x = 7;

- : unit = ()
val d4 : dcl =
  SeqDcl (SeqDcl (Const ("luigi", 26), Var ("x", 7)),
   SeqDcl (Const ("luigi", 26), Var ("x", 7)))

luigi = 26;
var x = 7;
luigi = 26;
var x = 7;

- : unit = ()

luigi = 26;
var x = 7;
luigi = 26;
var x = 7;
var y;
Vect[10];

- : unit = ()

....

val e1 : exp = Plus (Val "x", Num 17)
val e2 : exp = Val "z"
val e : exp = Mul (Plus (Val "x", Num 17), Val "z")

((x)+(17))*(z)

- : unit = ()
val c1 : cmd = UpArray ("A", Mul (Val "i", Val "j"), Plus (Val "x", Num 17))
val c2 : cmd =
  While (Val "z",
   SeqCmd (UpArray ("A", Mul (Val "i", Val "j"), Plus (Val "x", Num 17)),
    UpdVar ("z", Minus (Val "z", Num 1))))

while z {
A[(i)*(j)]=(x)+(17);
z=(z)-(1);
}


- : unit = ()


Aggiungere tests per l'intera Sintassi Astratta .................................*)

(* Tests: Semantic Structures *)
(* Tests: Semantic Functions *)
(* Tests: Programs and Computations *)
(* Tests: State Dumping *)



